<template>
  <div
    id="confirmModal"
    class="modal"
    tabindex="-1"
    role="dialog"
  >
    <div
      class="modal-dialog"
      role="document"
    >
      <div class="modal-content" v-if="deferred != null">
        <div class="modal-header">
          <h5 class="modal-title">Подтвердите действие</h5>
          <button
            type="button"
            class="close"
            data-dismiss="modal"
            aria-label="Close"
          >
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <p v-text="text"></p>
        </div>
        <div class="modal-footer">
          <button
            type="button"
            class="btn btn-primary"
            @click="success"
          >Да</button>
          <button
            type="button"
            class="btn btn-secondary"
            data-dismiss="modal"
            @click="failed"
          >Нет</button>
        </div>
      </div>
    </div>
  </div>
</template>


<script>
import $ from "jquery";

export default {
  data() {
    return {
      text: "",
      modal: null,
      deferred: null,
      payload: null
    };
  },
  methods: {
    open(text, payload = null) {
      this.text = text;
      this.payload = payload;
      this.modal.modal("show");
      this.deferred = new $.Deferred();
      return this.deferred.promise();
    },
    close() {
      this.text = "";
      this.deferred = null;
      this.payload = null;
      return this.modal.modal("hide");
    },
    success() {
        this.deferred.resolve(this.payload);
        this.close();
    },
    failed() {
        this.deferred.reject(this.payload);
    }
  },
  mounted() {
    this.modal = $("#confirmModal");
    this.modal.modal({
      backdrop: true,
      keyboard: true,
      show: false
    });
  }
};
</script>